# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from leo_msgs/Imu.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class Imu(genpy.Message):
  _md5sum = "d8596af47cb860f11b5f9246dd06f4fc"
  _type = "leo_msgs/Imu"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message holds the data retrieved from an Accel/Gyro+Temp IMU sensor
#
# The temperature field represents the temperature reported by the sensor in Degrees Celcius
# The gyro_* fields represent the rotational velocity in rad/s
# The accel_* fields represent the linear acceleration in m/s^2

time stamp
float32 temperature
float32 gyro_x
float32 gyro_y
float32 gyro_z
float32 accel_x
float32 accel_y
float32 accel_z
"""
  __slots__ = ['stamp','temperature','gyro_x','gyro_y','gyro_z','accel_x','accel_y','accel_z']
  _slot_types = ['time','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,temperature,gyro_x,gyro_y,gyro_z,accel_x,accel_y,accel_z

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Imu, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.temperature is None:
        self.temperature = 0.
      if self.gyro_x is None:
        self.gyro_x = 0.
      if self.gyro_y is None:
        self.gyro_y = 0.
      if self.gyro_z is None:
        self.gyro_z = 0.
      if self.accel_x is None:
        self.accel_x = 0.
      if self.accel_y is None:
        self.accel_y = 0.
      if self.accel_z is None:
        self.accel_z = 0.
    else:
      self.stamp = genpy.Time()
      self.temperature = 0.
      self.gyro_x = 0.
      self.gyro_y = 0.
      self.gyro_z = 0.
      self.accel_x = 0.
      self.accel_y = 0.
      self.accel_z = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I7f().pack(_x.stamp.secs, _x.stamp.nsecs, _x.temperature, _x.gyro_x, _x.gyro_y, _x.gyro_z, _x.accel_x, _x.accel_y, _x.accel_z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.stamp.secs, _x.stamp.nsecs, _x.temperature, _x.gyro_x, _x.gyro_y, _x.gyro_z, _x.accel_x, _x.accel_y, _x.accel_z,) = _get_struct_2I7f().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I7f().pack(_x.stamp.secs, _x.stamp.nsecs, _x.temperature, _x.gyro_x, _x.gyro_y, _x.gyro_z, _x.accel_x, _x.accel_y, _x.accel_z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.stamp.secs, _x.stamp.nsecs, _x.temperature, _x.gyro_x, _x.gyro_y, _x.gyro_z, _x.accel_x, _x.accel_y, _x.accel_z,) = _get_struct_2I7f().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I7f = None
def _get_struct_2I7f():
    global _struct_2I7f
    if _struct_2I7f is None:
        _struct_2I7f = struct.Struct("<2I7f")
    return _struct_2I7f
