# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from leo_msgs/WheelOdom.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class WheelOdom(genpy.Message):
  _md5sum = "5bb892afaf24a6d3bedf13c8fe986f2a"
  _type = "leo_msgs/WheelOdom"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message represents the pose and velocity of a differential wheeled robot, estimated from the wheel encoders.
#
# The velocity_* fields represent the linear and angular velocity of the robot.
# The pose_* fields represent the x, y and yaw pose of the robot w.r.t. the starting pose.
#
# The coordinate frame that represents the robot is located at the center of rotation.

time stamp
float32 velocity_lin
float32 velocity_ang
float32 pose_x
float32 pose_y
float32 pose_yaw
"""
  __slots__ = ['stamp','velocity_lin','velocity_ang','pose_x','pose_y','pose_yaw']
  _slot_types = ['time','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,velocity_lin,velocity_ang,pose_x,pose_y,pose_yaw

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WheelOdom, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.velocity_lin is None:
        self.velocity_lin = 0.
      if self.velocity_ang is None:
        self.velocity_ang = 0.
      if self.pose_x is None:
        self.pose_x = 0.
      if self.pose_y is None:
        self.pose_y = 0.
      if self.pose_yaw is None:
        self.pose_yaw = 0.
    else:
      self.stamp = genpy.Time()
      self.velocity_lin = 0.
      self.velocity_ang = 0.
      self.pose_x = 0.
      self.pose_y = 0.
      self.pose_yaw = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I5f().pack(_x.stamp.secs, _x.stamp.nsecs, _x.velocity_lin, _x.velocity_ang, _x.pose_x, _x.pose_y, _x.pose_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.stamp.secs, _x.stamp.nsecs, _x.velocity_lin, _x.velocity_ang, _x.pose_x, _x.pose_y, _x.pose_yaw,) = _get_struct_2I5f().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I5f().pack(_x.stamp.secs, _x.stamp.nsecs, _x.velocity_lin, _x.velocity_ang, _x.pose_x, _x.pose_y, _x.pose_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.stamp.secs, _x.stamp.nsecs, _x.velocity_lin, _x.velocity_ang, _x.pose_x, _x.pose_y, _x.pose_yaw,) = _get_struct_2I5f().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I5f = None
def _get_struct_2I5f():
    global _struct_2I5f
    if _struct_2I5f is None:
        _struct_2I5f = struct.Struct("<2I5f")
    return _struct_2I5f
